## wxpython4.0 4.2.0+dfsg

=== wscript ===
#!/usr/bin/python
#-----------------------------------------------------------------------------
#  WAF script for building and installing the wxPython extension modules.
#
# Author:      Robin Dunn
# Copyright:   (c) 2013-2020 by Total Control Software
# License:     wxWindows License
#-----------------------------------------------------------------------------

import sys
import os
import setuptools

try:
    from textwrap import indent
except ImportError:
    from buildtools.backports.textwrap3 import indent

from buildtools.config import Config, runcmd, msg, getMSVCInfo
cfg = Config(True)

#-----------------------------------------------------------------------------
# Options and configuration

APPNAME = 'wxPython'
VERSION = cfg.VERSION

isWindows = sys.platform.startswith('win')
isDarwin = sys.platform == "darwin"

top = '.'
out = 'build/waf'


def options(opt):
    if isWindows:
        opt.load('msvc')
    opt.load('compiler_c compiler_cxx')
    opt.load('python')

    opt.add_option('--debug', dest='debug', action='store_true', default=False,
                   help='Turn on debugger-related compile options.')
    opt.add_option('--python', dest='python', default='', action='store',
                   help='Full path to the Python executable to use.')
    opt.add_option('--wx_config', dest='wx_config', default='wx-config', action='store',
                   help='Full path to the wx-config script to be used for this build.')
    opt.add_option('--no_magic', dest='no_magic', action='store_true', default=False,
                   help='Don\'t use linker magic to enable wx libs to be bundled with '
                   'wxPython.  See build.py for more info.')
    opt.add_option('--mac_arch', dest='mac_arch', default='', action='store',
                   help='One or more comma separated architecture names to be used for '
                   'the Mac builds. Should be at least a subset of the architectures '
                   'used by wxWidgets and Python')
    opt.add_option('--gtk2', dest='gtk2', action='store_true', default=False,
                   help='On Linux build for gtk2 (default gtk3)')
    opt.add_option('--gtk3', dest='gtk3', action='store_true', default=True,
                   help='On Linux build for gtk3')
    opt.add_option('--no_msvc', dest='use_msvc', action='store_false', default=isWindows,
                   help='Set to use a MinGW toolchain')
    opt.add_option('--msvc_arch', dest='msvc_arch', default='x86', action='store',
                   help='The architecture to target for MSVC builds. Supported values '
                   'are: "x86" or "x64"')
    opt.add_option('--msvc_relwithdebug', dest='msvc_relwithdebug', action='store_true', default=False,
                   help='Turn on debug info for release builds for MSVC builds.')



def configure(conf):
    if conf.options.use_msvc:
        # Set up the MSVC compiler info for wxPython's build

        PYTHON = conf.options.python if conf.options.python else sys.executable
        info = getMSVCInfo(PYTHON, conf.options.msvc_arch, set_env=True)

        # WAF uses the VisualStudio version to select the compiler, rather than
        # the compiler version like we see elsewhere. Luckily we've got that
        # value in the MSVC info.
        msvc_version = f"msvc {info.vs_ver}"

        conf.env['MSVC_VERSIONS'] = [msvc_version]
        conf.env['MSVC_TARGETS'] = [conf.options.msvc_arch]
        conf.load('msvc')
    else:
        # Otherwise, use WAF's default setup for the C and C++ compiler
        conf.load('compiler_c compiler_cxx')
        if isWindows:
            conf.load('winres')

    # Set up Python
    if conf.options.python:
        conf.env.PYTHON = conf.options.python
    conf.load('python')
    conf.check_python_version(minver=(3,7,0))
    if isWindows:
        # Search for the Python headers without doing some stuff that could
        # incorrectly fail on Windows. See my_check_python_headers below.
        # TODO: Check if it can/should be used on other platforms too.
        conf.my_check_python_headers()
    else:
        conf.check_python_headers(features='pyext')

    # fetch and save the debug options
    conf.env.debug = conf.options.debug
    conf.env.msvc_relwithdebug = conf.options.msvc_relwithdebug

    conf.env.use_msvc = conf.options.use_msvc

    # Ensure that the headers in siplib and Phoenix's src dir can be found
    conf.env.INCLUDES_WXPY = ['sip/siplib', 'wx/include', 'src']

    if conf.options.use_msvc:
        # Windows/MSVC specific stuff

        cfg.finishSetup(debug=conf.env.debug)

        conf.env.INCLUDES_WX = cfg.includes
        conf.env.DEFINES_WX = cfg.wafDefines
        conf.env.CFLAGS = cfg.cflags
        conf.env.CXXFLAGS = cfg.cxxflags
        conf.env.CFLAGS_WX = list()
        conf.env.CXXFLAGS_WX = list()
        conf.env.LIBPATH_WX = cfg.libdirs
        conf.env.LIB_WX = cfg.libs
        conf.env.LIBFLAGS_WX = cfg.lflags

        _copyEnvGroup(conf.env, '_WX', '_WXADV')
        conf.env.LIB_WXADV += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXSTC')
        conf.env.LIB_WXSTC += cfg.makeLibName('stc')

        _copyEnvGroup(conf.env, '_WX', '_WXHTML')
        conf.env.LIB_WXHTML += cfg.makeLibName('html')

        _copyEnvGroup(conf.env, '_WX', '_WXGL')
        conf.env.LIB_WXGL += cfg.makeLibName('gl')

        _copyEnvGroup(conf.env, '_WX', '_WXWEBVIEW')
        conf.env.LIB_WXWEBVIEW += cfg.makeLibName('webview')

        _copyEnvGroup(conf.env, '_WX', '_WXXML')
        conf.env.LIB_WXXML += cfg.makeLibName('xml', isMSWBase=True)

        _copyEnvGroup(conf.env, '_WX', '_WXXRC')
        conf.env.LIB_WXXRC += cfg.makeLibName('xrc')

        _copyEnvGroup(conf.env, '_WX', '_WXRICHTEXT')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('richtext')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXMEDIA')
        conf.env.LIB_WXMEDIA += cfg.makeLibName('media')

        _copyEnvGroup(conf.env, '_WX', '_WXRIBBON')
        conf.env.LIB_WXRIBBON += cfg.makeLibName('ribbon')

        _copyEnvGroup(conf.env, '_WX', '_WXPROPGRID')
        conf.env.LIB_WXPROPGRID += cfg.makeLibName('propgrid')

        _copyEnvGroup(conf.env, '_WX', '_WXAUI')
        conf.env.LIB_WXAUI += cfg.makeLibName('aui')

        # ** Add code for new modules here (and below for non-MSW)


        # tweak the PYEXT compile and link flags if making a --debug build
        if conf.env.debug:
            for listname in ['CFLAGS_PYEXT', 'CXXFLAGS_PYEXT']:
                lst = conf.env[listname]
                for opt in '/Ox /MD /DNDEBUG'.split():
                    try:
                        lst.remove(opt)
                    except ValueError:
                        pass
                # NOTE: For --debug builds the /Z7 flag is used so the debug
                # info will be in each object file instead of a separate PDB
                # file. This will result in much faster builds since VC won't
                # have to serialize access to the .pdb file. OTOH, separate
                # PDB files are generated for the --msvc_relwithdebug option,
                # which is handled below in the makeETGRule() function.
                lst[1:1] = '/Od /MDd /Z7 /D_DEBUG'.split()

            conf.env['LINKFLAGS_PYEXT'].append('/DEBUG')
            conf.env['LIB_PYEXT'][0] += '_d'


    else: # not isWindows
        # TODO: Double-check that this works when using an installed wxWidgets
        wxConfigDir = cfg.findWxConfigDir(conf.options.wx_config)

        # Configuration stuff for non-Windows ports using wx-config
        # First finish configuring the Config object
        conf.env.wx_config = conf.options.wx_config
        cfg.finishSetup(conf.env.wx_config, conf.env.debug,
                        'mingw32' if isWindows and not conf.env.use_msvc else None)

        conf.env.CFLAGS = cfg.cflags[:]
        conf.env.CXXFLAGS = cfg.cxxflags[:]
        conf.env.CFLAGS_WX = list()
        conf.env.CXXFLAGS_WX = list()
        conf.env.CFLAGS_WXPY = list()
        conf.env.CXXFLAGS_WXPY = list()

        # Check wx-config exists and fetch some values from it
        rpath = ' --no-rpath' if not conf.options.no_magic else ''
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs core,net' + rpath,
                       uselib_store='WX', mandatory=True,
                       msg='Finding libs for WX')

        # Run it again with different libs options to get different
        # sets of flags stored to use with varous extension modules below.
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs adv,core,net' + rpath,
                       uselib_store='WXADV', mandatory=True,
                       msg='Finding libs for WXADV')

        libname = '' if cfg.MONOLITHIC else 'stc,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args=('--cxxflags --libs %score,net' % libname) + rpath,
                       uselib_store='WXSTC', mandatory=True,
                       msg='Finding libs for WXSTC')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs html,core,net' + rpath,
                       uselib_store='WXHTML', mandatory=True,
                       msg='Finding libs for WXHTML')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_GLCANVAS'):
            gl_libs = '--libs gl,core,net'
        else:
            gl_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + gl_libs + rpath,
                       uselib_store='WXGL', mandatory=True,
                       msg='Finding libs for WXGL')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_WEBVIEW'):
            wv_libs = '--libs webview,core,net'
        else:
            wv_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + wv_libs + rpath,
                       uselib_store='WXWEBVIEW', mandatory=True,
                       msg='Finding libs for WXWEBVIEW')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xml,core,net' + rpath,
                       uselib_store='WXXML', mandatory=True,
                       msg='Finding libs for WXXML')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xrc,xml,core,net' + rpath,
                       uselib_store='WXXRC', mandatory=True,
                       msg='Finding libs for WXXRC')

        libname = '' if cfg.MONOLITHIC else 'richtext,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs %score,net' % libname + rpath,
                       uselib_store='WXRICHTEXT', mandatory=True,
                       msg='Finding libs for WXRICHTEXT')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_MEDIACTRL'):
            mc_libs = '--libs media,core,net'
        else:
            mc_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + mc_libs + rpath,
                       uselib_store='WXMEDIA', mandatory=True,
                       msg='Finding libs for WXMEDIA')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs ribbon,core,net' + rpath,
                       uselib_store='WXRIBBON', mandatory=True,
                       msg='Finding libs for WXRIBBON')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs propgrid,core' + rpath,

=== ext/wxWidgets/CMakeLists.txt ===
#############################################################################
# Name:        CMakeLists.txt
# Purpose:     Primary CMake for wxWidgets
# Author:      Tobias Taschner
# Created:     2016-09-20
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

cmake_minimum_required(VERSION 3.0)

if(NOT CMAKE_CONFIGURATION_TYPES)
    get_property(HAVE_MULTI_CONFIG_GENERATOR GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    # Set default configuration types for multi-config generators
    if(HAVE_MULTI_CONFIG_GENERATOR)
        set(CMAKE_CONFIGURATION_TYPES "Debug;Release")
    endif()
endif()

file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" CMAKE_INSTALL_PREFIX)

# https://blog.kitware.com/cmake-and-the-default-build-type/
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(default_build_type "Debug")
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif()

# This block, particularly the versions used, should be kept in sync with
# samples/minimal/CMakeLists.txt.
if(APPLE AND NOT CMAKE_OSX_DEPLOYMENT_TARGET)
    # If no deployment target has been set default to the minimum supported
    # OS version (this has to be set before the first project() call)
    if(CMAKE_SYSTEM_NAME STREQUAL "iOS")
        set(CMAKE_OSX_DEPLOYMENT_TARGET 12.0 CACHE STRING "iOS Deployment Target")
    else()
        set(CMAKE_OSX_DEPLOYMENT_TARGET 10.10 CACHE STRING "macOS Deployment Target")
    endif()
endif()

include(build/cmake/policies.cmake NO_POLICY_SCOPE)

# Initialize variables for quick access to wx root dir in sub dirs
set(wxSOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(wxBINARY_DIR ${CMAKE_BINARY_DIR})
set(wxOUTPUT_DIR ${wxBINARY_DIR}/lib)

# parse the version number from wx/version.h and include in wxMAJOR_VERSION and wxMINOR_VERSION
file(READ "${wxSOURCE_DIR}/include/wx/version.h" WX_VERSION_H_CONTENTS)
string(REGEX MATCH "wxMAJOR_VERSION[ \t]+([0-9]+)"
    wxMAJOR_VERSION ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxMAJOR_VERSION ${wxMAJOR_VERSION})
string(REGEX MATCH "wxMINOR_VERSION[ \t]+([0-9]+)"
    wxMINOR_VERSION ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxMINOR_VERSION ${wxMINOR_VERSION})
string(REGEX MATCH "wxRELEASE_NUMBER[ \t]+([0-9]+)"
    wxRELEASE_NUMBER ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxRELEASE_NUMBER ${wxRELEASE_NUMBER})

# Determine if current version is a "Development" release
math(EXPR rel_dev "${wxMINOR_VERSION} % 2")
if(rel_dev)
    set(wxVERSION_IS_DEV TRUE)
else()
    set(wxVERSION_IS_DEV FALSE)
endif()

# parse the .so version from build/bakefiles/version.bkl
file(READ "${wxSOURCE_DIR}/build/bakefiles/version.bkl" WX_VERSION_BKL_CONTENTS)
string(REGEX MATCH "WX_CURRENT.>([0-9]+)"
    WX_CURRENT ${WX_VERSION_BKL_CONTENTS})
string(REGEX MATCH "([0-9]+)"
    WX_CURRENT ${WX_CURRENT})
string(REGEX MATCH "WX_REVISION.>([0-9]+)"
    WX_REVISION ${WX_VERSION_BKL_CONTENTS})
string(REGEX MATCH "([0-9]+)"
    WX_REVISION ${WX_REVISION})
string(REGEX MATCH "WX_AGE.>([0-9]+)"
    WX_AGE ${WX_VERSION_BKL_CONTENTS})
string(REGEX MATCH "([0-9]+)"
    WX_AGE ${WX_AGE})
math(EXPR wxSOVERSION_MAJOR "${WX_CURRENT} - ${WX_AGE}")
set(wxSOVERSION ${wxSOVERSION_MAJOR}.${WX_AGE}.${WX_REVISION})

set(wxVERSION ${wxMAJOR_VERSION}.${wxMINOR_VERSION}.${wxRELEASE_NUMBER})
set(wxCOPYRIGHT "2002-2022 wxWidgets")

set(wxLANGUAGES C CXX)
if(APPLE AND NOT CMAKE_VERSION VERSION_LESS "3.16")
    list(APPEND wxLANGUAGES OBJCXX)
endif()

project(wxWidgets VERSION ${wxVERSION} LANGUAGES ${wxLANGUAGES})

include(build/cmake/main.cmake)

# Set the default startup project for Visual Studio
if(wxBUILD_SAMPLES AND wxUSE_GUI)
    set_directory_properties(PROPERTIES VS_STARTUP_PROJECT minimal)
endif()

=== ext/wxWidgets/build/cmake/utils/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/utils/CMakeLists.txt
# Purpose:     CMake script for utilities
# Author:      Tobias Taschner
# Created:     2016-10-21
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

if(wxUSE_XRC)
    add_executable(wxrc "${wxSOURCE_DIR}/utils/wxrc/wxrc.cpp")
    wx_set_common_target_properties(wxrc)
    if(wxUSE_XML)
        wx_exe_link_libraries(wxrc wxxml)
    endif()
    wx_exe_link_libraries(wxrc wxbase)

    set(wxrc_output_name "wxrc")
    if(NOT WIN32_MSVC_NAMING)
        wx_get_flavour(lib_flavour "-")
        set(wxrc_output_name "wxrc-${wxMAJOR_VERSION}.${wxMINOR_VERSION}${lib_flavour}")
    endif()

    set_target_properties(wxrc PROPERTIES OUTPUT_NAME ${wxrc_output_name})

    set_target_properties(wxrc PROPERTIES FOLDER "Utilities")

    wx_install(TARGETS wxrc
        RUNTIME DESTINATION "bin"
        BUNDLE DESTINATION "bin"
        )

    if(NOT WIN32_MSVC_NAMING)
        if(IPHONE)
            set(EXE_SUFFIX ".app")
        else()
            set(EXE_SUFFIX ${CMAKE_EXECUTABLE_SUFFIX})
        endif()

        wx_install(CODE "execute_process( \
            COMMAND ${CMAKE_COMMAND} -E create_symlink \
            ${CMAKE_INSTALL_PREFIX}/bin/${wxrc_output_name}${EXE_SUFFIX} \
            ${CMAKE_INSTALL_PREFIX}/bin/wxrc${EXE_SUFFIX} \
            )"
        )
    endif()
endif()

# TODO: build targets for other utils

=== ext/wxWidgets/build/cmake/lib/base/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/base/CMakeLists.txt
# Purpose:     CMake file for base library
# Author:      Tobias Taschner
# Created:     2016-09-20
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(BASE_FILES BASE_CMN)
wx_append_sources(BASE_FILES BASE_AND_GUI_CMN)

if(WIN32)
    wx_append_sources(BASE_FILES BASE_WIN32)
    wx_append_sources(BASE_FILES BASE_AND_GUI_WIN32)
elseif(APPLE)
    wx_append_sources(BASE_FILES BASE_OSX_SHARED)
    if(WXOSX_COCOA)
        wx_append_sources(BASE_FILES BASE_AND_GUI_OSX_COCOA)
    endif()
elseif(UNIX)
    wx_append_sources(BASE_FILES BASE_UNIX)
endif()

wx_add_library(wxbase IS_BASE ${BASE_FILES})

if(wxUSE_ZLIB)
    wx_lib_include_directories(wxbase ${ZLIB_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${ZLIB_LIBRARIES})
endif()
if(wxUSE_REGEX)
    wx_lib_include_directories(wxbase ${REGEX_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${REGEX_LIBRARIES})
endif()
if(wxUSE_LIBLZMA)
    wx_lib_include_directories(wxbase ${LIBLZMA_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${LIBLZMA_LIBRARIES})
endif()
if(UNIX AND wxUSE_SECRETSTORE)
    wx_lib_include_directories(wxbase ${LIBSECRET_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${LIBSECRET_LIBRARIES})
endif()
if(wxUSE_LIBICONV)
    wx_lib_include_directories(wxbase ${ICONV_INCLUDE_DIR})
    wx_lib_link_libraries(wxbase PRIVATE ${ICONV_LIBRARIES})
endif()
if(wxUSE_THREADS AND CMAKE_THREAD_LIBS_INIT)
    wx_lib_link_libraries(wxbase PRIVATE ${CMAKE_THREAD_LIBS_INIT})
endif()

if(APPLE)
    wx_lib_link_libraries(wxbase
        PUBLIC
        "-framework CoreFoundation"
    )
    if(WXOSX_COCOA)
        wx_lib_link_libraries(wxbase
            PRIVATE
            "-framework Security"
            PUBLIC
            "-framework Carbon"
            "-framework Cocoa"
            "-framework IOKit"
            "-framework QuartzCore"
        )
    endif()
elseif(UNIX)
    wx_lib_link_libraries(wxbase PRIVATE dl)
endif()

=== ext/wxWidgets/build/cmake/lib/stc/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/stc/CMakeLists.txt
# Purpose:     CMake file for stc library
# Author:      Tobias Taschner
# Created:     2016-10-04
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(STC_FILES STC_CMN)

if(WXOSX_COCOA)
    wx_append_sources(STC_FILES STC_OSX_COCOA)
endif()

wx_add_builtin_library(wxscintilla
    src/stc/scintilla/lexers/LexA68k.cxx
    src/stc/scintilla/lexers/LexAbaqus.cxx
    src/stc/scintilla/lexers/LexAda.cxx
    src/stc/scintilla/lexers/LexAPDL.cxx
    src/stc/scintilla/lexers/LexAsm.cxx
    src/stc/scintilla/lexers/LexAsn1.cxx
    src/stc/scintilla/lexers/LexASY.cxx
    src/stc/scintilla/lexers/LexAU3.cxx
    src/stc/scintilla/lexers/LexAVE.cxx
    src/stc/scintilla/lexers/LexAVS.cxx
    src/stc/scintilla/lexers/LexBaan.cxx
    src/stc/scintilla/lexers/LexBash.cxx
    src/stc/scintilla/lexers/LexBasic.cxx
    src/stc/scintilla/lexers/LexBatch.cxx
    src/stc/scintilla/lexers/LexBibTeX.cxx
    src/stc/scintilla/lexers/LexBullant.cxx
    src/stc/scintilla/lexers/LexCaml.cxx
    src/stc/scintilla/lexers/LexCLW.cxx
    src/stc/scintilla/lexers/LexCmake.cxx
    src/stc/scintilla/lexers/LexCOBOL.cxx
    src/stc/scintilla/lexers/LexCoffeeScript.cxx
    src/stc/scintilla/lexers/LexConf.cxx
    src/stc/scintilla/lexers/LexCPP.cxx
    src/stc/scintilla/lexers/LexCrontab.cxx
    src/stc/scintilla/lexers/LexCsound.cxx
    src/stc/scintilla/lexers/LexCSS.cxx
    src/stc/scintilla/lexers/LexD.cxx
    src/stc/scintilla/lexers/LexDiff.cxx
    src/stc/scintilla/lexers/LexDMAP.cxx
    src/stc/scintilla/lexers/LexDMIS.cxx
    src/stc/scintilla/lexers/LexECL.cxx
    src/stc/scintilla/lexers/LexEDIFACT.cxx
    src/stc/scintilla/lexers/LexEiffel.cxx
    src/stc/scintilla/lexers/LexErlang.cxx
    src/stc/scintilla/lexers/LexErrorList.cxx
    src/stc/scintilla/lexers/LexEScript.cxx
    src/stc/scintilla/lexers/LexFlagship.cxx
    src/stc/scintilla/lexers/LexForth.cxx
    src/stc/scintilla/lexers/LexFortran.cxx
    src/stc/scintilla/lexers/LexGAP.cxx
    src/stc/scintilla/lexers/LexGui4Cli.cxx
    src/stc/scintilla/lexers/LexHaskell.cxx
    src/stc/scintilla/lexers/LexHex.cxx
    src/stc/scintilla/lexers/LexHTML.cxx
    src/stc/scintilla/lexers/LexInno.cxx
    src/stc/scintilla/lexers/LexJSON.cxx
    src/stc/scintilla/lexers/LexKix.cxx
    src/stc/scintilla/lexers/LexKVIrc.cxx
    src/stc/scintilla/lexers/LexLaTeX.cxx
    src/stc/scintilla/lexers/LexLisp.cxx
    src/stc/scintilla/lexers/LexLout.cxx
    src/stc/scintilla/lexers/LexLua.cxx
    src/stc/scintilla/lexers/LexMagik.cxx
    src/stc/scintilla/lexers/LexMake.cxx
    src/stc/scintilla/lexers/LexMarkdown.cxx
    src/stc/scintilla/lexers/LexMatlab.cxx
    src/stc/scintilla/lexers/LexMetapost.cxx
    src/stc/scintilla/lexers/LexMMIXAL.cxx
    src/stc/scintilla/lexers/LexModula.cxx
    src/stc/scintilla/lexers/LexMPT.cxx
    src/stc/scintilla/lexers/LexMSSQL.cxx
    src/stc/scintilla/lexers/LexMySQL.cxx
    src/stc/scintilla/lexers/LexNimrod.cxx
    src/stc/scintilla/lexers/LexNsis.cxx
    src/stc/scintilla/lexers/LexNull.cxx
    src/stc/scintilla/lexers/LexOpal.cxx
    src/stc/scintilla/lexers/LexOScript.cxx
    src/stc/scintilla/lexers/LexPascal.cxx
    src/stc/scintilla/lexers/LexPB.cxx
    src/stc/scintilla/lexers/LexPerl.cxx
    src/stc/scintilla/lexers/LexPLM.cxx
    src/stc/scintilla/lexers/LexPO.cxx
    src/stc/scintilla/lexers/LexPOV.cxx
    src/stc/scintilla/lexers/LexPowerPro.cxx
    src/stc/scintilla/lexers/LexPowerShell.cxx
    src/stc/scintilla/lexers/LexProgress.cxx
    src/stc/scintilla/lexers/LexProps.cxx
    src/stc/scintilla/lexers/LexPS.cxx
    src/stc/scintilla/lexers/LexPython.cxx
    src/stc/scintilla/lexers/LexR.cxx
    src/stc/scintilla/lexers/LexRebol.cxx
    src/stc/scintilla/lexers/LexRegistry.cxx
    src/stc/scintilla/lexers/LexRuby.cxx
    src/stc/scintilla/lexers/LexRust.cxx
    src/stc/scintilla/lexers/LexScriptol.cxx
    src/stc/scintilla/lexers/LexSmalltalk.cxx
    src/stc/scintilla/lexers/LexSML.cxx
    src/stc/scintilla/lexers/LexSorcus.cxx
    src/stc/scintilla/lexers/LexSpecman.cxx
    src/stc/scintilla/lexers/LexSpice.cxx
    src/stc/scintilla/lexers/LexSQL.cxx
    src/stc/scintilla/lexers/LexSTTXT.cxx
    src/stc/scintilla/lexers/LexTACL.cxx
    src/stc/scintilla/lexers/LexTADS3.cxx
    src/stc/scintilla/lexers/LexTAL.cxx
    src/stc/scintilla/lexers/LexTCL.cxx
    src/stc/scintilla/lexers/LexTCMD.cxx
    src/stc/scintilla/lexers/LexTeX.cxx
    src/stc/scintilla/lexers/LexTxt2tags.cxx
    src/stc/scintilla/lexers/LexVB.cxx
    src/stc/scintilla/lexers/LexVerilog.cxx
    src/stc/scintilla/lexers/LexVHDL.cxx
    src/stc/scintilla/lexers/LexVisualProlog.cxx
    src/stc/scintilla/lexers/LexYAML.cxx
    src/stc/scintilla/lexlib/Accessor.cxx
    src/stc/scintilla/lexlib/CharacterCategory.cxx
    src/stc/scintilla/lexlib/CharacterSet.cxx
    src/stc/scintilla/lexlib/LexerBase.cxx
    src/stc/scintilla/lexlib/LexerModule.cxx
    src/stc/scintilla/lexlib/LexerNoExceptions.cxx
    src/stc/scintilla/lexlib/LexerSimple.cxx
    src/stc/scintilla/lexlib/PropSetSimple.cxx
    src/stc/scintilla/lexlib/StyleContext.cxx
    src/stc/scintilla/lexlib/WordList.cxx
    src/stc/scintilla/src/AutoComplete.cxx
    src/stc/scintilla/src/CallTip.cxx
    src/stc/scintilla/src/CaseConvert.cxx
    src/stc/scintilla/src/CaseFolder.cxx
    src/stc/scintilla/src/Catalogue.cxx
    src/stc/scintilla/src/CellBuffer.cxx
    src/stc/scintilla/src/CharClassify.cxx
    src/stc/scintilla/src/ContractionState.cxx
    src/stc/scintilla/src/Decoration.cxx
    src/stc/scintilla/src/Document.cxx
    src/stc/scintilla/src/EditModel.cxx
    src/stc/scintilla/src/EditView.cxx
    src/stc/scintilla/src/Editor.cxx
    src/stc/scintilla/src/ExternalLexer.cxx
    src/stc/scintilla/src/Indicator.cxx
    src/stc/scintilla/src/KeyMap.cxx
    src/stc/scintilla/src/LineMarker.cxx
    src/stc/scintilla/src/MarginView.cxx
    src/stc/scintilla/src/PerLine.cxx
    src/stc/scintilla/src/PositionCache.cxx
    src/stc/scintilla/src/RESearch.cxx
    src/stc/scintilla/src/RunStyles.cxx
    src/stc/scintilla/src/ScintillaBase.cxx
    src/stc/scintilla/src/Selection.cxx
    src/stc/scintilla/src/Style.cxx
    src/stc/scintilla/src/UniConversion.cxx
    src/stc/scintilla/src/ViewStyle.cxx
    src/stc/scintilla/src/XPM.cxx
)
target_include_directories(wxscintilla PRIVATE
    ${wxSOURCE_DIR}/src/stc/scintilla/include
    ${wxSOURCE_DIR}/src/stc/scintilla/lexlib
    ${wxSOURCE_DIR}/src/stc/scintilla/src
    )
target_compile_definitions(wxscintilla PRIVATE
    NO_CXX11_REGEX
    __WX__
    SCI_LEXER
    LINK_LEXERS
)

wx_target_enable_precomp(wxscintilla "${wxSOURCE_DIR}/src/stc/scintilla/include/Scintilla.h")
wx_add_library(wxstc ${STC_FILES})
wx_lib_include_directories(wxstc
    ${wxSOURCE_DIR}/src/stc/scintilla/include
    ${wxSOURCE_DIR}/src/stc/scintilla/lexlib
    ${wxSOURCE_DIR}/src/stc/scintilla/src
    )
wx_lib_compile_definitions(wxstc
    NO_CXX11_REGEX
    __WX__
    SCI_LEXER
    LINK_LEXERS
)
wx_lib_link_libraries(wxstc PRIVATE wxscintilla)
if(WXMSW)
    wx_lib_link_libraries(wxstc PRIVATE imm32)
endif()

=== ext/wxWidgets/build/cmake/lib/webview/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/webview/CMakeLists.txt
# Purpose:     CMake file for webview library
# Author:      Tobias Taschner
# Created:     2016-10-03
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

function(wx_webview_copy_webview2_loader target)
    if(NOT WXMSW OR NOT wxUSE_WEBVIEW_EDGE OR NOT TARGET ${target})
        return()
    endif()

    if(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(WEBVIEW2_ARCH x86)
    else()
        set(WEBVIEW2_ARCH x64)
    endif()

    add_custom_command(TARGET ${target} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy
        "${WEBVIEW2_PACKAGE_DIR}/build/native/${WEBVIEW2_ARCH}/WebView2Loader.dll"
        "$<TARGET_FILE_DIR:${target}>/WebView2Loader.dll")
endfunction()


wx_append_sources(WEBVIEW_FILES WEBVIEW_CMN)

if(WXMSW)
    wx_append_sources(WEBVIEW_FILES WEBVIEW_MSW)
elseif(WXGTK)
    if(wxUSE_WEBVIEW_WEBKIT2)
        wx_append_sources(WEBVIEW_FILES WEBVIEW2_GTK)
    elseif(wxUSE_WEBVIEW_WEBKIT)
        wx_append_sources(WEBVIEW_FILES WEBVIEW_GTK)
    endif()
elseif(APPLE)
    wx_append_sources(WEBVIEW_FILES WEBVIEW_OSX_SHARED)
endif()

wx_add_library(wxwebview ${WEBVIEW_FILES})

if(APPLE)
    wx_lib_link_libraries(wxwebview PUBLIC "-framework WebKit")
elseif(WXMSW)
    if(wxUSE_WEBVIEW_EDGE)
        # Update the following variables if updating WebView2 SDK
        set(WEBVIEW2_VERSION "1.0.705.50")
        set(WEBVIEW2_URL "https://www.nuget.org/api/v2/package/Microsoft.Web.WebView2/${WEBVIEW2_VERSION}")
        set(WEBVIEW2_SHA256 "6a34bb553e18cfac7297b4031f3eac2558e439f8d16a45945c22945ac404105d")

        set(WEBVIEW2_DEFAULT_PACKAGE_DIR "${CMAKE_BINARY_DIR}/packages/Microsoft.Web.WebView2.${WEBVIEW2_VERSION}")

        if(NOT EXISTS ${WEBVIEW2_PACKAGE_DIR})
            unset(WEBVIEW2_PACKAGE_DIR CACHE)
        endif()
        find_path(WEBVIEW2_PACKAGE_DIR
            NAMES build/native/include/WebView2.h
            PATHS
                "${PROJECT_SOURCE_DIR}/3rdparty/webview2"
                ${WEBVIEW2_DEFAULT_PACKAGE_DIR}
        )

        if (NOT WEBVIEW2_PACKAGE_DIR)
            message(STATUS "WebView2 SDK not found locally, downloading...")
            set(WEBVIEW2_PACKAGE_DIR ${WEBVIEW2_DEFAULT_PACKAGE_DIR} CACHE PATH "WebView2 SDK PATH" FORCE)
            file(DOWNLOAD
                ${WEBVIEW2_URL}
                ${CMAKE_BINARY_DIR}/webview2.nuget
                EXPECTED_HASH SHA256=${WEBVIEW2_SHA256})
            file(MAKE_DIRECTORY ${WEBVIEW2_PACKAGE_DIR})
            execute_process(COMMAND
                "${CMAKE_COMMAND}" -E tar x "${CMAKE_BINARY_DIR}/webview2.nuget"
                WORKING_DIRECTORY "${WEBVIEW2_PACKAGE_DIR}"
            )
        endif()
        set(WEBVIEW2_PACKAGE_DIR ${WEBVIEW2_PACKAGE_DIR} CACHE INTERNAL "" FORCE)

        wx_lib_include_directories(wxwebview "${WEBVIEW2_PACKAGE_DIR}/build/native/include")
        if(NOT MSVC)
            wx_lib_include_directories(wxwebview "${wxSOURCE_DIR}/include/wx/msw/wrl")
            if (NOT wxBUILD_MONOLITHIC)
                target_compile_options(wxwebview PRIVATE -Wno-unknown-pragmas)
            endif()
        endif()

        if (wxUSE_WEBVIEW_EDGE_STATIC)
            target_link_directories(wxwebview PUBLIC
                $<BUILD_INTERFACE:${WEBVIEW2_PACKAGE_DIR}/build/native/$(LibrariesArchitecture)/>
            )
        else()
            wx_webview_copy_webview2_loader(wxwebview)
        endif()

    endif()
elseif(WXGTK)
    if(LIBSOUP_FOUND)
        wx_lib_include_directories(wxwebview ${LIBSOUP_INCLUDE_DIRS})
        wx_lib_link_libraries(wxwebview PUBLIC ${LIBSOUP_LIBRARIES})
    endif()
    if(wxUSE_WEBVIEW_WEBKIT2)
        wx_lib_include_directories(wxwebview ${WEBKIT2_INCLUDE_DIR})
        wx_lib_link_libraries(wxwebview PUBLIC ${WEBKIT2_LIBRARIES})
    elseif(wxUSE_WEBVIEW_WEBKIT)
        wx_lib_include_directories(wxwebview ${WEBKIT_INCLUDE_DIR})
        wx_lib_link_libraries(wxwebview PUBLIC ${WEBKIT_LIBRARIES})
    endif()
endif()

# webkit extension plugin
# we can't use (all of the) macros and functions because this library should
# always be build as a shared libary, and not included in the monolithic build.
if(WXGTK AND wxUSE_WEBVIEW_WEBKIT2)
    wx_append_sources(WEBKIT2_EXT_FILES WEBVIEW_WEBKIT2_EXTENSION)
    add_library(wxwebkit2_ext SHARED ${WEBKIT2_EXT_FILES})
    wx_set_target_properties(wxwebkit2_ext IS_PLUGIN)
    set_target_properties(wxwebkit2_ext PROPERTIES NO_SONAME 1)

    # Change output name to match expected name in webview_webkit2.cpp: webkit2_ext*
    set(lib_unicode)
    if(wxUSE_UNICODE)
        set(lib_unicode "u")
    endif()

    set(lib_rls)
    set(lib_dbg)
    if(WIN32_MSVC_NAMING)
        set(lib_dbg "d")
    endif()

    if(wxVERSION_IS_DEV)
        set(WX_WEB_EXT_VERSION "${wxMAJOR_VERSION}.${wxMINOR_VERSION}.${wxRELEASE_NUMBER}")
    else()
        set(WX_WEB_EXT_VERSION "${wxMAJOR_VERSION}.${wxMINOR_VERSION}")
    endif()

    set_target_properties(wxwebkit2_ext PROPERTIES
        OUTPUT_NAME       "webkit2_ext${lib_unicode}${lib_rls}-${WX_WEB_EXT_VERSION}"
        OUTPUT_NAME_DEBUG "webkit2_ext${lib_unicode}${lib_dbg}-${WX_WEB_EXT_VERSION}"
        PREFIX ""
    )

    target_include_directories(wxwebkit2_ext PRIVATE
        ${LIBSOUP_INCLUDE_DIRS}
        ${WEBKIT2_INCLUDE_DIR}
        )
    target_link_libraries(wxwebkit2_ext PUBLIC
        ${LIBSOUP_LIBRARIES}
        ${WEBKIT2_LIBRARIES}
        )

    wx_install(TARGETS wxwebkit2_ext LIBRARY DESTINATION "lib/wx/${WX_WEB_EXT_VERSION}/web-extensions")

    wx_add_dependencies(wxwebview wxwebkit2_ext)
endif()

=== ext/wxWidgets/build/cmake/lib/xml/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/xml/CMakeLists.txt
# Purpose:     CMake file for xml library
# Author:      Tobias Taschner
# Created:     2016-09-20
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(XML_FILES XML)
wx_add_library(wxxml IS_BASE ${XML_FILES})
wx_lib_link_libraries(wxxml PRIVATE ${EXPAT_LIBRARIES})
wx_lib_include_directories(wxxml ${EXPAT_INCLUDE_DIRS})

=== ext/wxWidgets/build/cmake/tests/base/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/tests/base/CMakeLists.txt
# Purpose:     CMake file for base test
# Author:      Tobias Taschner
# Created:     2016-10-31
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

set(TEST_SRC
    test.cpp
    any/anytest.cpp
    archive/archivetest.cpp
    archive/ziptest.cpp
    archive/tartest.cpp
    arrays/arrays.cpp
    base64/base64.cpp
    cmdline/cmdlinetest.cpp
    config/fileconf.cpp
    config/regconf.cpp
    datetime/datetimetest.cpp
    events/evthandler.cpp
    events/evtlooptest.cpp
    events/evtsource.cpp
    events/stopwatch.cpp
    events/timertest.cpp
    exec/exec.cpp
    file/dir.cpp
    file/filefn.cpp
    file/filetest.cpp
    filekind/filekind.cpp
    filename/filenametest.cpp
    filesys/filesystest.cpp
    fontmap/fontmaptest.cpp
    formatconverter/formatconvertertest.cpp
    fswatcher/fswatchertest.cpp
    hashes/hashes.cpp
    interactive/output.cpp
    interactive/input.cpp
    intl/intltest.cpp
    lists/lists.cpp
    log/logtest.cpp
    longlong/longlongtest.cpp
    mbconv/convautotest.cpp
    mbconv/mbconvtest.cpp
    misc/dynamiclib.cpp
    misc/environ.cpp
    misc/metatest.cpp
    misc/misctests.cpp
    misc/module.cpp
    misc/pathlist.cpp
    misc/typeinfotest.cpp
    net/ipc.cpp
    net/socket.cpp
    net/webrequest.cpp
    regex/regextest.cpp
    regex/wxregextest.cpp
    scopeguard/scopeguardtest.cpp
    strings/iostream.cpp
    strings/numformatter.cpp
    strings/strings.cpp
    strings/stdstrings.cpp
    strings/tokenizer.cpp
    strings/unichar.cpp
    strings/unicode.cpp
    strings/vararg.cpp
    strings/crt.cpp
    strings/vsnprintf.cpp
    strings/hexconv.cpp
    streams/datastreamtest.cpp
    streams/ffilestream.cpp
    streams/fileback.cpp
    streams/filestream.cpp
    streams/iostreams.cpp
    streams/largefile.cpp
    streams/lzmastream.cpp
    streams/memstream.cpp
    streams/socketstream.cpp
    streams/sstream.cpp
    streams/stdstream.cpp
    streams/tempfile.cpp
    streams/textstreamtest.cpp
    streams/zlibstream.cpp
    textfile/textfiletest.cpp
    thread/atomic.cpp
    thread/misc.cpp
    thread/queue.cpp
    thread/tls.cpp
    uris/ftp.cpp
    uris/uris.cpp
    uris/url.cpp
    vectors/vectors.cpp
    weakref/evtconnection.cpp
    weakref/weakref.cpp
    xlocale/xlocale.cpp

    testprec.h
    testableframe.h
    testdate.h
    testfile.h
    archive/archivetest.h
    streams/bstream.h
    )

if(wxUSE_XML)
    list(APPEND TEST_SRC xml/xmltest.cpp)
endif()

set(TEST_DATA
    intl/fr/internat.mo
    intl/fr/internat.po
    intl/ja/internat.mo
    intl/ja/internat.po
    horse.bmp
    horse.png
    horse.xpm
    testdata.conf
    )

wx_add_test(test_base CONSOLE ${TEST_SRC}
    DATA ${TEST_DATA}
    )
if(wxUSE_SOCKETS)
    wx_exe_link_libraries(test_base wxnet)
endif()
if(wxUSE_XML)
    wx_exe_link_libraries(test_base wxxml)
endif()

=== debian/changelog ===
wxpython4.0 (4.2.0+dfsg-3) unstable; urgency=medium

  * d/control: update wx3.0-doc Suggests to wx3.2-doc (Closes: #1032867)

 -- Scott Talbert <swt@techie.net>  Wed, 15 Mar 2023 20:27:44 -0400

wxpython4.0 (4.2.0+dfsg-2) unstable; urgency=medium

  * d/control: make sip-tools requirements match python3-sipbuild
    (Closes: #1031040)
  * Rebuild for kicad (Closes: #1031785)

 -- Scott Talbert <swt@techie.net>  Thu, 23 Feb 2023 19:34:57 -0500

wxpython4.0 (4.2.0+dfsg-1) unstable; urgency=medium

  * Update d/copyright excluded files for new release
  * Update to new upstream release 4.2.0
  * Build with wxWidgets 3.2
  * Refresh patches for new upstream release
  * d/rules: update list of tests to skip
  * d/control: update Standards-Version to 4.6.1
  * d/copyright: remove superfluous file patterns
  * Add lintian override for missing js source which isn't missing

 -- Scott Talbert <swt@techie.net>  Tue, 13 Sep 2022 23:38:45 -0400

wxpython4.0 (4.0.7+dfsg-15) unstable; urgency=medium

  * Fix reproducibility after sip 6.6.2 changes

 -- Scott Talbert <swt@techie.net>  Sat, 09 Jul 2022 13:28:36 -0400

wxpython4.0 (4.0.7+dfsg-14) unstable; urgency=medium

  * Fix FTBFS with sip 6.6.2 (Closes: #1011697)

 -- Scott Talbert <swt@techie.net>  Tue, 28 Jun 2022 21:51:29 -0400

wxpython4.0 (4.0.7+dfsg-13) unstable; urgency=medium

  [ Olly Betts ]
  * debian/control: Remove myself from "Uploaders" as I'm actively
    involved in maintaining this package.

  [ Scott Talbert ]
  * Fix FTBFS with sip 6.5.1 (Closes: #1005637)
  * Update Standards-Version to 4.6.0 (no changes needed)
  * Add missing BD on python3-six
  * Fix a bunch of Python 3.10 issues

 -- Scott Talbert <swt@techie.net>  Wed, 16 Feb 2022 20:23:33 -0500

wxpython4.0 (4.0.7+dfsg-12) unstable; urgency=medium

  * Fix FTBFS with sip 6.3.1 (Closes: #997500)

 -- Scott Talbert <swt@techie.net>  Mon, 25 Oct 2021 20:10:23 -0400

wxpython4.0 (4.0.7+dfsg-11) unstable; urgency=medium

  [ Dmitry Shachnev ]
  * Add support for building with SIP v6:
    - Cherry-pick upstream change to remove wrong enum code.
    - Add sip6.patch to adapt for API changes in SIP v6.
    - Replace sip5-tools build-dependency with sip-tools.

 -- Scott Talbert <swt@techie.net>  Mon, 16 Aug 2021 18:45:38 -0400

wxpython4.0 (4.0.7+dfsg-10) unstable; urgency=medium

  * Build with sip 5 and build private sip module (Closes: #934925, #966057)

 -- Scott Talbert <swt@techie.net>  Sun, 17 Jan 2021 15:58:38 -0500

wxpython4.0 (4.0.7+dfsg-9) unstable; urgency=medium

  * Fix FTBFS with doxygen 1.9.0 (Closes: #979014)

 -- Scott Talbert <swt@techie.net>  Thu, 07 Jan 2021 22:43:13 -0500

wxpython4.0 (4.0.7+dfsg-8) unstable; urgency=medium

  * Remove BD on python3-requests (not needed)
  * Update standards version to 4.5.1 (no changes needed)

 -- Scott Talbert <swt@techie.net>  Thu, 31 Dec 2020 15:34:38 -0500

wxpython4.0 (4.0.7+dfsg-7) unstable; urgency=medium

  * Rebuild for Python 3.9 (Closes: #976845)
  * Backport upstream fix for wxPseudoDC.FindObjects crash (Closes: #977047)
  * Backport upstream fix for wxCustomDataObject.GetData crash

 -- Scott Talbert <swt@techie.net>  Thu, 10 Dec 2020 23:21:45 -0500

=== debian/control ===
Source: wxpython4.0
Section: python
Priority: optional
Maintainer: wxWidgets Maintainers <team+wx@tracker.debian.org>
Uploaders: Scott Talbert <swt@techie.net>
Build-Depends:
    debhelper-compat (= 13),
    dh-python,
    doxygen,
    libgtk-3-dev,
    libwxgtk3.2-dev,
    libwxgtk-media3.2-dev,
    libwxgtk-webview3.2-dev,
    python3-all,
    python3-all-dev,
    python3-numpy,
    python3-pil,
    python3-pypdf2,
    python3-pytest,
    python3-pytest-timeout,
    python3-pytest-xdist,
    python3-setuptools,
    python3-sipbuild (>= 6.6.2),
    python3-six,
    sip-tools (>= 6.6.2),
    xauth,
    xvfb,
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
Homepage: https://www.wxpython.org/

Package: python3-wxgtk4.0
Architecture: any
Depends: python3-pil, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: wx3.2-doc
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to the wxGTK library and the
 wxPython runtime support libraries.  This is the Phoenix reimplementation of
 wxPython.

Package: python3-wxgtk-media4.0
Architecture: any
Depends: python3-wxgtk4.0 (= ${binary:Version}), ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.media)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxMediaCtrl.  This is the Phoenix
 reimplementation of wxPython.

Package: python3-wxgtk-webview4.0
Architecture: any
Depends: python3-wxgtk4.0 (= ${binary:Version}), ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.html2)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxWebView.  This is the Phoenix
 reimplementation of wxPython.

Package: wxpython-tools
Architecture: all
Depends: python3-wxgtk4.0, ${python3:Depends}, ${misc:Depends}
Provides: python-wxtools
Replaces: python-wxtools
Conflicts: python-wxtools
Description: Tools from the wxPython distribution
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides support utilities and common files for wxPython.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

export DOXYGEN=/usr/bin/doxygen
export PYBUILD_SYSTEM=custom
export PYBUILD_BUILD_ARGS_python3=python{version} -u build.py dox touch etg --nodoc sip build_py --use_syswx --gtk3 --extra_waf "-v"
export PYBUILD_CLEAN_ARGS=python{version} build.py clean
export PYBUILD_BEFORE_INSTALL=mkdir -p {destdir}{install_dir}
export PYBUILD_INSTALL_ARGS_python3=python{version} build.py install_py --destdir={destdir} --extra_setup="--install-layout=deb"
SKIP_TESTS='not (test_frameRestore or test_newIdRef03)'
export PYBUILD_TEST_ARGS=xvfb-run -a python{version} -m pytest -v --boxed --timeout=60 -k $(SKIP_TESTS) unittests || true
export PYBUILD_DISABLE=configure

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_install:
	dh_install
	# These are packaged in the -media subpackage:
	rm -f debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_media.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/media.py*
	# These are packaged in the -webview subpackage:
	rm -f debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_html2.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/html2.py*

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

## wxpython4.0 4.2.1%2Bdfsg

=== debian/changelog ===
wxpython4.0 (4.2.1+dfsg-3) unstable; urgency=medium

  * Fix SyntaxWarnings with Python 3.12 (Closes: #1058929)
  * Remove unneeded BD on python3-pypdf2

 -- Scott Talbert <swt@techie.net>  Thu, 21 Dec 2023 20:32:55 -0500

wxpython4.0 (4.2.1+dfsg-2) unstable; urgency=medium

  * Fix FTBFS with doxygen 1.9.7+ (Closes: #1051155)

 -- Scott Talbert <swt@techie.net>  Wed, 06 Dec 2023 18:27:20 -0500

wxpython4.0 (4.2.1+dfsg-1) unstable; urgency=medium

  * Update to new upstream release 4.2.1
  * Update Standards-Version to 4.6.2
  * Rules-Requires-Root: no
  * Add missing BD on python3-pytest-forked to fix tests

 -- Scott Talbert <swt@techie.net>  Thu, 15 Jun 2023 21:10:58 -0400

=== debian/control ===
--- 
+++ 
@@ -15,8 +15,8 @@
     python3-all-dev,
     python3-numpy,
     python3-pil,
-    python3-pypdf2,
     python3-pytest,
+    python3-pytest-forked,
     python3-pytest-timeout,
     python3-pytest-xdist,
     python3-setuptools,
@@ -25,10 +25,11 @@
     sip-tools (>= 6.6.2),
     xauth,
     xvfb,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
 Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
 Homepage: https://www.wxpython.org/
+Rules-Requires-Root: no
 
 Package: python3-wxgtk4.0
 Architecture: any
